#ifndef USART3_F1_H
#define USART3_F1_H

#include "stm32f1xx_hal.h"
#include "usart_common.h"
#include "comm.h"

/* public functions */
void usart3_init(TComm *comm_dev,UART_InitTypeDef *conf,TUSART_IRQ_Priorities *priorities);
void usart3_config(TComm *comm_dev,UART_InitTypeDef *conf);
void usart3_set_priorities(TComm *comm_dev,TUSART_IRQ_Priorities *priorities);
/* IRQ functions */
unsigned char usart3_send_irq(unsigned char first_byte);
unsigned char usart3_enable_tx_irq(void);
unsigned char usart3_receive_irq(void);
unsigned char usart3_cancel_receive_irq(void);
/* DMA functions */
unsigned char usart3_send_dma(unsigned char *data,unsigned short int length);
unsigned char usart3_receive_dma(unsigned char *data,unsigned short int length);
unsigned char usart3_cancel_receive_dma(void);

#endif
