#ifndef _DYN_DEVICES_H
#define _DYN_DEVICES_H

// servo modules
#define       SERVO_DX113     0x0071
#define       SERVO_DX116     0x0074
#define       SERVO_DX117     0x0075
#define       SERVO_AX12A     0x000C
#define       SERVO_AX12W     0x012C
#define       SERVO_AX18A     0x0012
#define       SERVO_RX10      0x000A
#define       SERVO_MX12W     0x0168
#define       SERVO_MX28      0x001D
#define       SERVO_RX24F     0x0018
#define       SERVO_RX28      0x001C
#define       SERVO_RX64      0x0040
#define       SERVO_MX64      0x0136
#define       SERVO_EX106     0x006B
#define       SERVO_MX106     0x0140
#define       SERVO_XL320     0x015E

#define       IS_SERVO(model) (model==SERVO_DX113 || model==SERVO_DX116 || model==SERVO_DX117 || model==SERVO_AX12A \
                               model==SERVO_AX12W || model==SERVO_AX18A || model==SERVO_RX10 || model==SERVO_MX12W \
                               model==SERVO_MX28 || model==SERVO_RX24F || model==SERVO_RX28 || model==SERVO_RX64 \
                               model==SERVO_MX64 || model==SERVO_EX106 || model==SERVO_MX106 || model==SERVO_XL320)

#endif
