#include "buffer.h"
#include <stdio.h>

int main(void)
{
  unsigned char data_in[MAX_BUFFER_LENGTH];
  unsigned char data_out[MAX_BUFFER_LENGTH];
  TBuffer buffer;
  int i=0,j=0;

  buffer_init(&buffer);
  printf("Bytes written to the buffer: %d\n",buffer_write_byte(&buffer,0x55));
  printf("Bytes read from the buffer: %d\n",buffer_read_byte(&buffer,data_in));  
  printf("Data read from the buffer: %d\n",data_in[0]);
  printf("Bytes read from the buffer: %d\n",buffer_read_byte(&buffer,data_in));  

  /* init data */
  for(i=0;i<MAX_BUFFER_LENGTH;i++)
  {
    data_in[i]=i;
    data_out[i]=0x00;
  }
  printf("Bytes written to the buffer: %d\n",buffer_write(&buffer,data_in,MAX_BUFFER_LENGTH));
  printf("Bytes read from the buffer: %d\n",buffer_read(&buffer,data_out,MAX_BUFFER_LENGTH));
  for(i=0;i<MAX_BUFFER_LENGTH/16;i++)
  {
    for(j=0;j<16;j++)
      printf("%3d,",data_out[i*16+j]);
    printf("\n");
  }
  printf("Bytes written to the buffer: %d\n",buffer_write(&buffer,data_in,MAX_BUFFER_LENGTH));
  printf("Bytes written to the buffer: %d\n",buffer_write_byte(&buffer,0x55));
}
